<%@ page import="org.wso2.carbon.dataservices.ui.beans.Config" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.Data" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.Query" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.dataservices.common.DBConstants" %>
<jsp:useBean id="dataService" class="org.wso2.carbon.dataservices.ui.beans.Data" scope="session"/>
<jsp:useBean id="newConfig" class="org.wso2.carbon.dataservices.ui.beans.Config" scope="session"/>
<%
    //retrieve form values set in addDataSource.jsp page
    String serviceName = request.getParameter("serviceName");
    String datasourceId = request.getParameter("datasourceId");
    String datasourceType = request.getParameter("datasourceType");
    String selectBox = request.getParameter("selectbox");
    String driverClass = request.getParameter(DBConstants.RDBMS.DRIVER);
    String jdbcUrl = request.getParameter(DBConstants.RDBMS.PROTOCOL);
    String dsUserName = request.getParameter(DBConstants.RDBMS.USER);
    String dsPassword = request.getParameter(DBConstants.RDBMS.PASSWORD);
    String minPoolSize = request.getParameter(DBConstants.RDBMS.MIN_POOL_SIZE);
    String maxPoolSize = request.getParameter(DBConstants.RDBMS.MAX_POOL_SIZE);
    String validateQuery = request.getParameter(DBConstants.RDBMS.VALIDATION_QUERY);

    String excelDatasource = request.getParameter(DBConstants.Excel.DATASOURCE);

    String rdfDatasource = request.getParameter(DBConstants.RDF.DATASOURCE);

    String csvDatasource = request.getParameter(DBConstants.CSV.DATASOURCE);
    String csvColumnSeperator = request.getParameter(DBConstants.CSV.COLUMN_SEPARATOR);
    String csvStartingRow = request.getParameter(DBConstants.CSV.STARTING_ROW);
    String csvMaxRowCount = request.getParameter(DBConstants.CSV.MAX_ROW_COUNT);
    String csvHasHeader = request.getParameter(DBConstants.CSV.HAS_HEADER);

    String jndiContextClass = request.getParameter(DBConstants.JNDI.INITIAL_CONTEXT_FACTORY);
    String jndiProviderUrl = request.getParameter(DBConstants.JNDI.PROVIDER_URL);
    String jndiResourceName = request.getParameter(DBConstants.JNDI.RESOURCE_NAME);
    String jndiUserName = request.getParameter(DBConstants.JNDI.USERNAME);
    String jndiPassword = request.getParameter(DBConstants.JNDI.PASSWORD);

    String gspreadDatasource = request.getParameter(DBConstants.GSpread.DATASOURCE);
    String gspreadVisibility = request.getParameter(DBConstants.GSpread.VISIBILITY);
    String gspreadUserName = request.getParameter(DBConstants.GSpread.USERNAME);
    String gspreadPassword = request.getParameter(DBConstants.GSpread.PASSWORD);

    String carbonDatasourceName = request.getParameter(DBConstants.CarbonDatasource.NAME);
        
    String flag = request.getParameter("flag");
    flag = (flag == null) ? "" : flag;
    String forwardTo = "dataSources.jsp";
    boolean remove = true;
    if(datasourceId != null){
        Config dsConfig = dataService.getConfig(datasourceId);
        if (dsConfig == null) {
        	dsConfig = newConfig;
        	dataService.setConfig(dsConfig);
        }
        if(dsConfig != null){
            if(flag.equals("delete")){
                ArrayList<Query> queryList= dataService.getQueries();
                if(queryList.size() >= 0){
                    for(int a=0; a < queryList.size(); a++){
                        if(datasourceId.equals(queryList.get(a).getConfigToUse())){
                            String message = "Data source "+datasourceId+" has been used by queries. Please remove them to proceed.";
                            CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
                            forwardTo = "dataSources.jsp";
                            remove = false;
                         }
                    }
                }
                 if(remove){
                    dataService.removeConfig(dsConfig);
                 }
            }else{
                if (DBConstants.DataSourceTypes.RDBMS.equals(datasourceType)) {
                    dsConfig.updateProperty(DBConstants.RDBMS.DRIVER, driverClass);
                    dsConfig.updateProperty(DBConstants.RDBMS.PROTOCOL, jdbcUrl);
                    dsConfig.updateProperty(DBConstants.RDBMS.USER, dsUserName);
                    dsConfig.updateProperty(DBConstants.RDBMS.PASSWORD, dsPassword);
                    dsConfig.updateProperty(DBConstants.RDBMS.MIN_POOL_SIZE, minPoolSize);
                    dsConfig.updateProperty(DBConstants.RDBMS.MAX_POOL_SIZE, maxPoolSize);
                    dsConfig.updateProperty(DBConstants.RDBMS.VALIDATION_QUERY, validateQuery);
                } else if (DBConstants.DataSourceTypes.EXCEL.equals(datasourceType)) {
                    dsConfig.updateProperty(DBConstants.Excel.DATASOURCE, excelDatasource);
                } else if (DBConstants.DataSourceTypes.RDF.equals(datasourceType)) {
                    dsConfig.updateProperty(DBConstants.RDF.DATASOURCE, rdfDatasource);
                } else if (DBConstants.DataSourceTypes.CSV.equals(datasourceType)) {
                    dsConfig.updateProperty(DBConstants.CSV.DATASOURCE, csvDatasource);
                    dsConfig.updateProperty(DBConstants.CSV.COLUMN_SEPARATOR, csvColumnSeperator);
                    dsConfig.updateProperty(DBConstants.CSV.STARTING_ROW, csvStartingRow);
                    dsConfig.updateProperty(DBConstants.CSV.MAX_ROW_COUNT, csvMaxRowCount);
                    dsConfig.updateProperty(DBConstants.CSV.HAS_HEADER, csvHasHeader);
                } else if (DBConstants.DataSourceTypes.JNDI.equals(datasourceType)) {
                    dsConfig.updateProperty(DBConstants.JNDI.INITIAL_CONTEXT_FACTORY, jndiContextClass);
                    dsConfig.updateProperty(DBConstants.JNDI.PROVIDER_URL, jndiProviderUrl);
                    dsConfig.updateProperty(DBConstants.JNDI.RESOURCE_NAME, jndiResourceName);
                    dsConfig.updateProperty(DBConstants.JNDI.USERNAME, jndiUserName);
                    dsConfig.updateProperty(DBConstants.JNDI.PASSWORD, jndiPassword);
                } else if (DBConstants.DataSourceTypes.GDATA_SPREADSHEET.equals(datasourceType)) {
                    dsConfig.updateProperty(DBConstants.GSpread.DATASOURCE, gspreadDatasource);
                    dsConfig.updateProperty(DBConstants.GSpread.VISIBILITY, gspreadVisibility);
                    dsConfig.updateProperty(DBConstants.GSpread.USERNAME, gspreadUserName);
                    dsConfig.updateProperty(DBConstants.GSpread.PASSWORD, gspreadPassword);
                } else if (DBConstants.DataSourceTypes.CARBON.equals(datasourceType)) {
                    if (carbonDatasourceName == null || carbonDatasourceName.length() == 0) {
                        String message = "Please select a valid data source name";
                        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
                        forwardTo = "addDataSource.jsp?configId=" + datasourceId;
                    } else {
                        dsConfig.updateProperty(DBConstants.CarbonDatasource.NAME, carbonDatasourceName);
                    }
                }
            }   

        }


    }   
%>
 <table>
     <input type="hidden" id="selectbox" value="<%=selectBox%>" />
     <input type="hidden" id="configId" value="<%=request.getParameter("configId")%>" />
     <input type="hidden" id="selectedType" value="<%=request.getParameter("selectedType")%>" />
     <input type="hidden" id="serviceName" value="<%=serviceName%>" />
 </table>

<script type="text/javascript">
   /* if(document.getElementById('selectbox').value != null){
       location.href = 'addDataSource.jsp?configId='+document.getElementById('configId').value+'&selectedType='+document.getElementById('selectedType').value;
    }else{*/
       /*location.href="dataSources.jsp";*/
    //}
</script>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
