<%@ page import="org.apache.axis2.databinding.utils.BeanUtil" %>
<%@ page import="org.wso2.carbon.dataservices.ui.beans.*" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.dataservices.common.DBConstants" %>
<jsp:include page="../dialog/display_messages.jsp"/>
<jsp:useBean id="dataService" class="org.wso2.carbon.dataservices.ui.beans.Data" scope="session"/>
<%
    //retrieve form values set in addQuery.jsp page
    String serviceName = request.getParameter("serviceName");
    String queryId = request.getParameter("queryId");
    String datasource = request.getParameter("datasource");
    String sql = request.getParameter("sql");
    String flag = request.getParameter("flag");
    String rowName = request.getParameter("txtDataServiceRowName");
    String nameSpace = request.getParameter("txtDataServiceRowNamespace");
    String element = request.getParameter("txtDataServiceWrapElement");
    String workBookName = request.getParameter("txtExcelWorkbookName");
    String startingRow = request.getParameter("txtExcelStartingRow");
    String maxRowCount = request.getParameter("txtExcelMaxRowCount");
    String headerColumns = request.getParameter("txtExcelHeaderColumns");
    String gSpreadWorkSheetNumber = request.getParameter("txtGSpreadWorksheetNumber");
    String gSpreadStartingRow = request.getParameter("txtGSpreadStartingRow");
    String gSpreadMaxRowCount = request.getParameter("txtGSpreadMaxRowCount");
    String gHasHeaders =  request.getParameter("txtGSpreadHeaderColumns");
    String inputEvent = request.getParameter("inputEventTrigger");
    String outputEvent = request.getParameter("outputEventTrigger");
    String xsltPath = request.getParameter("xsltPath");
    String edit = request.getParameter("edit");
    String timeout = request.getParameter("timeout");
    String fetchDirection = request.getParameter("fetchDirection");
    String fetchSize = request.getParameter("fetchSize");
    String maxFieldSize = request.getParameter("maxFieldSize");
    String maxRows = request.getParameter("maxRows");

    edit = (edit == null) ? "" : edit ;
    ArrayList<Query> queryList = dataService.getQueries();
    Query query ;
    Result result;
    String forwardTo = "";
    boolean remove = true;

    /* clear the validator session bean for add input mappings page */
    if (flag != null && flag.equals("inputMapping")) {
        session.setAttribute("validators", new ArrayList());
    }

    if(queryId != null){
       query = dataService.getQuery(queryId);
       //if have existing queries
       if(query != null){
           if(edit.equals("false")){
             //checking for queries with the same query Id.
             String message = "Please enter a different Query ID. A Query ID called "+queryId+" already exists.";
             CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
             forwardTo = "addQuery.jsp";
             flag = "error";
           }
           if(flag.equals("delete")){
             ArrayList<Operation> operation = dataService.getOperations();
             ArrayList<Resource> resource = dataService.getResources();
             if(operation != null){
                 // checking for operations which has used the query before deleting.
                 for(int a=0; a < operation.size(); a++){
                     if(queryId.equals(operation.get(a).getCallQuery().getHref())){
                        String message = "Query Id "+queryId+" has been used by operation(s). Please remove the relevant operation(s) to proceed.";
                        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
                        forwardTo = "queries.jsp";
                        flag = "error";
                        remove = false;
                     }
                 }
             }
             if(resource != null){
                 for(int a =0; a < resource.size(); a++){
                     // checking for resources which has used the query before deleting.
                     if(queryId.equals(resource.get(a).getCallQuery().getHref())){
                       String message = "Query Id "+queryId+" has been used by resource(s). Please remove the relevant resource(s) to proceed.";
                       CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
                       forwardTo = "queries.jsp";
                       flag = "error";
                       remove = false;
                     }
                 }
             }
             if(remove){
                dataService.removeQuery(query);
             }
           }else{
                query.setId(queryId);
                query.setConfigToUse(datasource);
                if (outputEvent != null) {
                    query.setOutputEventTrigger(outputEvent);
                }
                if (inputEvent != null) {
                    query.setInputEventTrigger(inputEvent);
                }
                Config con = dataService.getConfig(datasource);
                if (con.getDataSourceType().equals("RDBMS")) {
                    if (query.getProperties().size() > 0) {
                        query.updateProperty(DBConstants.RDBMS.QUERY_TIMEOUT, timeout);
                        query.updateProperty(DBConstants.RDBMS.FETCH_DIRECTION, fetchDirection);
                        query.updateProperty(DBConstants.RDBMS.FETCH_SIZE, fetchSize);
                        query.updateProperty(DBConstants.RDBMS.MAX_FIELD_SIZE, maxFieldSize);
                        query.updateProperty(DBConstants.RDBMS.MAX_ROWS, maxRows);
                    } else {
                        query.addProperty(DBConstants.RDBMS.QUERY_TIMEOUT, timeout);
                        query.addProperty(DBConstants.RDBMS.FETCH_DIRECTION, fetchDirection);
                        query.addProperty(DBConstants.RDBMS.FETCH_SIZE, fetchSize);
                        query.addProperty(DBConstants.RDBMS.MAX_FIELD_SIZE, maxFieldSize);
                        query.addProperty(DBConstants.RDBMS.MAX_ROWS, maxRows);
                    }
                        query.setSql(sql);
                } else if(con.getDataSourceType().equals("EXCEL")){
                    ExcelQuery excel = new ExcelQuery();
                    excel.setWorkBookName(workBookName);
                    excel.setHasHeaders(headerColumns);
                    excel.setMaxRowCount(maxRowCount);
                    excel.setStartingRow(startingRow);
                    query.setExcel(excel);
                } else if(con.getDataSourceType().equals("GDATA_SPREADSHEET")){
                    GSpreadQuery gspread = new GSpreadQuery();
                    gspread.setWorkSheetNumber(Integer.parseInt(gSpreadWorkSheetNumber));
                    gspread.setMaxRowCount(Integer.parseInt(gSpreadMaxRowCount));
                    gspread.setStartingRow(Integer.parseInt(gSpreadStartingRow));
                    gspread.setHasHeaders(gHasHeaders);
                    query.setGSpread(gspread);
                } else if(con.getDataSourceType().equals("CARBON_DATASOURCE")) {
                    query.setSql(sql);
                }
               result = query.getResult();
               if(query.getResult() != null){
                   result.setNamespace(nameSpace);
                   result.setResultWrapper(element);
                   result.setRowName(rowName);
                   if(xsltPath != null && xsltPath.trim().length() > 0) {
                        result.setXsltPath(xsltPath);
                   } else {
                       result.setXsltPath(null);
                   }
               }else{
                   if(!nameSpace.equals("") || !element.equals("") || !rowName.equals("")){
                     result = new Result();
                     result.setNamespace(nameSpace);
                     result.setResultWrapper(element);
                     result.setRowName(rowName);
                     if(xsltPath != null && xsltPath.trim().length() > 0) {
                        result.setXsltPath(xsltPath);
                     }
                     query.setResult(result);  
                   }
               }
            }
        }else{
            query = new Query();
            query.setId(queryId);
            if (outputEvent != null) {
                    query.setOutputEventTrigger(outputEvent);
            }
            if (inputEvent != null) {
                    query.setInputEventTrigger(inputEvent);
            }
            Config con = dataService.getConfig(datasource);
            
            //query.setConfigToUse(con.getDataSourceType());
            query.setConfigToUse(datasource);
            if(con.getDataSourceType().equals("RDBMS")){
                query.addProperty(DBConstants.RDBMS.QUERY_TIMEOUT, timeout);
                query.addProperty(DBConstants.RDBMS.FETCH_DIRECTION, fetchDirection);
                query.addProperty(DBConstants.RDBMS.FETCH_SIZE, fetchSize);
                query.addProperty(DBConstants.RDBMS.MAX_FIELD_SIZE, maxFieldSize);
                query.addProperty(DBConstants.RDBMS.MAX_ROWS, maxRows);
                query.setSql(sql);
            } else if(con.getDataSourceType().equals("EXCEL")){
                ExcelQuery excel = new ExcelQuery();
                excel.setWorkBookName(workBookName);
                excel.setHasHeaders(headerColumns);
                excel.setMaxRowCount(maxRowCount);
                excel.setStartingRow(startingRow);
                query.setExcel(excel);
                excel.buildXML();
            } else if(con.getDataSourceType().equals("GDATA_SPREADSHEET")){
                GSpreadQuery gspread = new GSpreadQuery();
                gspread.setWorkSheetNumber(Integer.parseInt(gSpreadWorkSheetNumber));
                gspread.setMaxRowCount(Integer.parseInt(gSpreadMaxRowCount));
                gspread.setStartingRow(Integer.parseInt(gSpreadStartingRow));
                gspread.setHasHeaders(gHasHeaders);
                query.setGSpread(gspread);
            } else if (con.getDataSourceType().equals("CARBON_DATASOURCE")) {
                query.setSql(sql);
            }
            if(!nameSpace.equals("") || !element.equals("") || !rowName.equals("")){
                     result = new Result();
                     result.setNamespace(nameSpace);
                     result.setResultWrapper(element);
                     result.setRowName(rowName);
                     if(xsltPath != null && xsltPath.trim().length() > 0) {
                        result.setXsltPath(xsltPath);
                     }
                     query.setResult(result);

            }           
            dataService.addQuery(query);           
        }
    }  
  
%>

<table style="display:none">
    <tr>
        <td><input id="flag" name="flag" value="<%=flag%>">
        </td>
    </tr>
    <tr><input type="hidden" id="serviceName" value="<%=serviceName%>" /> </tr>
    <tr><input type="hidden" id="datasource" value="<%=datasource%>" /> </tr>
    <tr><input type="hidden" id="queryId" value="<%=queryId%>" /> </tr>
    <tr><input type="hidden" id="sql" value="<%=sql%>" /> </tr>
    <tr><input type="hidden" id="rowName" value="<%=rowName%>" /></tr>
    <tr><input type="hidden" id="ns" value="<%=nameSpace%>" /> </tr>
    <tr><input type="hidden" id="element" value="<%=element%>" /> </tr>
</table>

<script type="text/javascript">
    var flag = document.getElementById('flag').value;
    
    if (flag == 'inputMapping') {
        location.href = 'addInputMapping.jsp?queryId='+document.getElementById('queryId').value;
    }
    else if(flag == 'save' || flag == 'delete'){
        location.href = 'queries.jsp?serviceName='+document.getElementById('serviceName').value;
    }
    else if (flag == 'outputMapping') {
        location.href = 'addOutputMapping.jsp?queryId='+document.getElementById('queryId').value;
    } else if(flag == "error"){
        location.href = "<%=forwardTo%>";
    } else if(flag == "event") {
        location.href = 'addEvents.jsp?queryId='+document.getElementById('queryId').value;
    }


</script>